      PROGRAM FACOM

C
C AUTEUR: W.J. VERMIN
C
C DIT PROGRAMMA LOST DE 'FACOM' PUZZEL OP.
C DEZE PUZZEL BESTAAT UIT DE 12 VERSCHILLENDE VLAKKE PENTOMINO'S
C DIE MOETEN WORDEN SAMENGEVOEGD TOT EEN BLOK MET AFMETINGEN
C VAN 3*4*5, 20*3*1, 10*3*2 ETC.
C OOK ANDERE VORMEN KUNNEN ALS OPGAVE WORDEN OPGEGEVEN.
C
C METHODE
C
C EERST WORDT WAT ADMINISTRATIEF WERK VERRICHT:
C FILES GEOPEND, INPUT GEVRAAGD OVER DE TE VOLGEN CODE:
C SCALAIR OF GEVECTORISEERD (MITS DE COMPILER DAT KAN UITERAARD)
C TEVENS WORDT DE MOGELIJKHEID GEBODEN, EEN EERDERE BEREKENING
C TE HERVATTEN. OP GEZETTE TIJDEN WORDEN DE RELEVANTE GEGEVENS
C NAMELIJK GEDUMPT.
C DE SYMMETRIEOPERATIES (ALLE COMBINATIES VAN
C SPIEGELING EN TWEETALLIGE ASSEN EN VIERTALLIGE ASSEN) WORDEN
C GEGENEREERD. (SUBROUTINE  MSYM)
C DE BUREN VAN ALLE HOKJES IN DE TE VULLEN RUIMTE
C WORDEN VASTGELEGD. (SUBROUTINE  MBUUR)
C DE DIMENSIES VAN DE TE VULLEN RUIMTE WORDEN BEPAALD (SUBROUTINE
C                                                      MSPACE)
C DE SYMMETRIEOPERATIES, DIE DE TE VULLEN RUIMTE IN ZICHZELF
C OVERVOEREN WORDEN BEPAALD (SUBROUTINE SYMSPA)
C ALLE MOGELIJKE POSITIES VAN ALLE PENTOMINO'S IN DE TE VULLEN
C RUIMTE WORDEN VASTGELEGD IN TABEL T (SUBROUTINES GENPOS EN
C                                      ALLPOS)
C IN ARRAY STNR DAT EVENVEEL ENTRIES HEEFT ALS TABEL T,
C KOMEN DE NUMMERS VAN DE STENEN
C
C ER WORDT EEN PASSENDE PENTOMINO GEKOZEN. IN ARRAY LL
C WORDT BIJGEHOUDEN, WELKE ENTRIES IN T DOOR DE LAATST GELEGDE
C STEEN NIET MEER GELEGD KUNNEN WORDEN. ALLE NOG OPENSTAANDE
C MOGELIJKHEDEN WORDEN GEKOPIEERD NAAR HET EINDE VAN T EN STNR.
C OP DE ALDUS GEVORMDE NIEUWE MOGELIJKHEDEN WORDT HETZELFDE
C ALGORITME RECURSIEF TOEGEPAST.
C
C BOVENSTAAND ALGORITME WERKT, MAAR NIET ERG EFFICIENT. GEZIEN
C HET GROTE AANTAL MOGELIJKHEDEN WAS HET NOODZAKELIJK ENKELE
C OPTIMALISERINGEN AAN TE BRENGEN:
C
C -1 ONDERZOEK, OF DE NOG NIET BEZETTE RUIMTEN ELK EEN VEELVOUD
C    VAN 5 AANEENGESLOTEN CELLEN BEVAT. (FUNCTION  TESTNS)
C
C -2 ONDERZOEK, OF DE OVERGEBLEVEN PENTOMINO'S IN PRINCIPE ELK
C    EEN PLAATS KUNNEN VINDEN IN DE OVERGEBLEVEN RUIMTE
C
C -3 ONDERZOEK, OF ELKE CEL IN PRINCIPE GEVULD KAN WORDEN MET
C    EEN OVERGEBLEVEN PENTOMINO
C
C -4 STEL VAST, OF EEN OVERGEBLEVEN PENTOMINO OP NOG MAR EEN
C    PLAATS GELEGD KAN WORDEN
C
C -5 ONDERZOEK STEEDS EERST DIE PENTOMINO, DIE NOG DE MINSTE
C    MOGELIJKHEDEN HEEFT OM TE WORDEN GEPLAATST
C
C -6 VERMIJDT DUBBELE OPLOSSINGEN (SUBROUTINE  TESTEQ)

         IMPLICIT INTEGER(A-Z)

         PARAMETER(VOLGST=12345,VOLGSM=12346,TERUG=12347,STOPPE=12348)
         PARAMETER(NSYMMAX=49)
         PARAMETER(NSYM0=4)
         PARAMETER(NGSMAX=24)
         PARAMETER(NSTEEN=12)
         PARAMETER(NKUB=5)
         PARAMETER(NKS=NKUB*NSTEEN)
         PARAMETER(NTMAX=15000)
         PARAMETER(NSPACE=200)
         PARAMETER(NSTMAX=NSTEEN*(4+NSTEEN))
         PARAMETER(NFDUMP=2)
         DOUBLE PRECISION CPTIME,TIMER,TTT,TMAX,DTIMER,DTIME,TDUMP
         DOUBLE PRECISION CPT0,TIMER0
         CHARACTER*8 FDUMP
         COMMON /BLOCK/ NN(3)
         COMMON /INVAR/ LOOP,NR,STATUS,NPROB,NBEGIN,NBEGIN1,
     +                  NEIND,METHOD,NBINGO,LSPACE,NSTACK,
     +                  NTMAX1,NRMAX,NSYMS,NS1,NS2

         COMMON /TIJD/ TIMER,TMAX
         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS
         COMMON /CDUMP/ FDUMP(NFDUMP)
         COMMON /PR/ PRLOOP,PRBING
         DIMENSION SYMOP(3,NSYMMAX)
         DIMENSION SYMS(3,NSYMMAX)
         DIMENSION STEEN(3,NKUB,NSTEEN)
         DIMENSION GS(3,NKUB,NGSMAX)
         DIMENSION SPACE(NSPACE)
         DIMENSION TPACE(NSPACE)
         DIMENSION IPACE(NSPACE)
         DIMENSION UPACE(NSPACE)
         DIMENSION BUUR(6,NSPACE)
         DIMENSION NPOSS(NSTEEN),NPOSE(NSTEEN)
         DIMENSION T(NTMAX,NKUB)
         DIMENSION LL(NTMAX)
         DIMENSION STNR(NTMAX)
         DIMENSION LSTNR(NTMAX)
         DIMENSION STACK(NSTMAX)
         DIMENSION AANTAL(NSTEEN)
         DIMENSION BANTAL(NSTEEN)
         DIMENSION IANTAL(NSTEEN)
         DIMENSION PRSTCK(NSTEEN)
         CHARACTER*(NSTEEN) SNAAM
         CHARACTER*1 ANT
         CHARACTER*80 FOPLOS
C EENHEIDSOPERATIE, ROTATIE 90 GRADEN, VERWISSELEN X EN Z AS
C EN SPIEGELING:
         DATA ((SYMOP(I,J),I=1,3),J=1,NSYM0) /1,2,3, -2,1,3, 3,1,2
     +    ,-1,2,3/

C RESP Y P N V T U X Z W F I L

         DATA (((STEEN(I,J,K),I=1,2),J=1,NKUB),K=1,NSTEEN) /
     +         0,0, 1,0, 2,0, 3,0, 2,1,
     +         0,0, 1,0, 2,0, 1,1, 2,1,
     +         0,0, 1,0, 2,0, 2,1, 3,1,
     +         0,0, 1,0, 2,0, 2,1, 2,2,
     +         0,0, 1,0, 2,0, 2,1, 2,-1,
     +         0,0, 1,0, 2,0, 0,1, 2,1,
     +         0,0, 1,0, 2,0, 1,1, 1,-1,
     +         0,0, 1,0, 1,1, 1,2, 2,2,
     +         0,0, 1,0, 1,1, 2,1, 2,2,
     +         0,0, 1,0, 2,0, 1,-1, 2,1,
     +         0,0, 1,0, 2,0, 3,0, 4,0,
     +         0,0, 1,0, 2,0, 3,0, 3,1 /
         DATA ((STEEN(3,J,K),J=1,NKUB),K=1,NSTEEN) /NKS*0/
         DATA SNAAM /'YPNVTUXZWFIL'/

         CALL DEFAULT
         KDUMP=NFDUMP
         OPEN(ISCRA,FILE='TESTOUT')
         CLOSE(ISCRA,STATUS='DELETE')
         OPEN(ISCRA,FILE='TESTOUT')

         PRINT *,'OUTPUTFILE? (MAX 80 CHARS)'
         READ(*,'(A80)') FOPLOS
         OPEN(IOPLOS,FILE=FOPLOS)
         CLOSE(IOPLOS,STATUS='DELETE')
         OPEN(IOPLOS,FILE=FOPLOS)

  100    CONTINUE
         PRINT *,'METHODE? 1 IS SCALAIR, 2 IS VECTOR'
         READ *,METHOD
         IF(METHOD.NE.1 .AND. METHOD.NE.2) GOTO 100
         PRINT *,'DUMPINTERVAL (SEC)?'
         READ *,DTIME
  200    CONTINUE
         PRINT *,'LEZEN VAN FILE Y/J/N/y/j/n ?'
         READ (*,'(A)',END=200) ANT
         TIMER=CPTIME()
         DTIMER=CPTIME()
         IF (ANT.EQ.'Y' .OR. ANT.EQ.'J' .OR.
     +       ANT.EQ.'y' .OR. ANT.EQ.'j') THEN
            KDUMP=KIESF()
            CALL LEES(SPACE,IPACE,BUUR,T,LL,STNR,PRSTCK,AANTAL,
     +                STACK,SYMS,IANTAL,N123,FDUMP(KDUMP))
            WRITE(IU,*) 'N1 N2 N3 IS',NN
            CALL LTMAX
            TIMER=CPTIME()
            DTIMER=TIMER
            GOTO 2030
         ENDIF
         IF (ANT.EQ.'N' .OR. ANT.EQ.'n') GOTO 300
         GOTO 200
  300    CONTINUE
         CALL DFDUMP
         CALL LTMAX
         PRINT *,'START BEPALEN SYMMETRIE OPERATIES'
         CALL MSYM(SYMOP,NSYM0,NSYM,NSYMMAX)
         PRINT *,'AANTAL SYMMETRIE OPERATIES IS ',NSYM
         WRITE (ISCRA,400) ((SYMOP(I,J),I=1,3),J=1,NSYM)
  400    FORMAT(' ',3I4)

         CALL MSPACE(SPACE,IPACE,LSPACE,N123)
         CALL SYMSPA(SYMOP,SYMS,NSYM,NSYMS,SPACE,N123)

C DEBUG
         DO 401 I=1,NSYMS
 401     PRINT *,(SYMS(J,I),J=1,3)
         CALL MBUUR(SPACE,N123,BUUR)
         NT=0
         DO 600 LS=1,NSTEEN
            CALL GENPOS(STEEN(1,1,LS),GS,NGS,SYMOP,NSYM)
            WRITE(ISCRA,*) ' STEEN ',SNAAM(LS:LS),' ',NGS
            WRITE(ISCRA,500) (((GS(K,J,L),K=1,3),J=1,NKUB),L=1,NGS)
            CALL ALLPOS(LS,GS,NGS,T,NT,STNR,SPACE,N123)
            IF (LS.EQ.1) THEN
               NPOSS(LS)=1
            ELSE
               NPOSS(LS)=NPOSE(LS-1)+1
            ENDIF
            NPOSE(LS)=NT
            PRINT *,' ',SNAAM(LS:LS),' ',NGS,NPOSE(LS)-NPOSS(LS)+1
  500       FORMAT(5(3I3,1X))
  600    CONTINUE

C
C HIER ZIJN ALLE MOGELIJKE POSITIES VAN ALLE STENEN BEPAALD EN IN T
C GENOTEERD.
C
         PRINT *,CPTIME()-TIMER
         TIMER=CPTIME()
         DTIMER=TIMER

         NR=1
         NBEGIN=1
         NPROB=0
         NEIND=NT
         NSTACK=0
         STATUS=VOLGST
         LOOP=0
         NRMAX=2
         NBINGO=0
         NTMAX1=0
         IANTAL(1)=0
         NS1=NSYMS

         DO 900 I=1,NSTEEN
            AANTAL(I)=0
            IANTAL(I)=I
  900    CONTINUE

         DO 1000 I=1,NT
            AANTAL(STNR(I))=AANTAL(STNR(I))+1
 1000    CONTINUE

C
C PLAATS DE MOEILIJKST TE PLAATSEN STEEN (AANTAL IS HET KLEINST)
C VOORAAN IN T EN STNR AARAYS
C

         L=NEIND+1
         DO 1100 I=1,NSTEEN
            IF(AANTAL(I).LT.L) THEN
               L=AANTAL(I)
               K=I
            ENDIF
 1100    CONTINUE

         LB=1
         DO 1200 I=1,K-1
            LB=LB+AANTAL(I)
 1200    CONTINUE
         LE=LB+L-1

C
C PAS AANTAL AAN
C
         DO 1300 I=K,2,-1
            AANTAL(I)=AANTAL(I-1)
 1300    CONTINUE
         AANTAL(1)=L

         NBEGIN1=AANTAL(1)+1

C
C COPIEER EERST STENEN NAAR EIND, SCHUIF VERVOLGENS DE
C VOORLIGGENDE STENEN OP EN COPIEER DE STENEN MET LAAGSTE
C AANTAL NAAR BEGIN
C
         K=NEIND
         DO 1500 I=LB,LE
            K=K+1
            STNR(K)=STNR(I)
            DO 1400 J=1,NKUB
               T(K,J)=T(I,J)
 1400       CONTINUE
 1500    CONTINUE

         DO 1700 I=LB-1,1,-1
            STNR(I+L)=STNR(I)
            DO 1600 J=1,NKUB
               T(I+L,J)=T(I,J)
 1600       CONTINUE
 1700    CONTINUE

         DO 1900 I=1,L
            STNR(I)=STNR(I+NEIND)
            DO 1800 J=1,NKUB
               T(I,J)=T(I+NEIND,J)
 1800       CONTINUE
 1900    CONTINUE

         DO 1910 I=NBEGIN,NBEGIN1-1
            LL(I)=1
 1910    CONTINUE

C
C DEBUG
C
         CALL CHAANT(T,STNR,NBEGIN,NEIND,AANTAL,1,13,'FACODUMP')
C
C STARTLOOP
C

 2000    CONTINUE

C KIJK OF HET TIJD IS EEN DUMP TE MAKEN.
C WE ROEPEN CPTIME NIET BIJ ELKE LOOP AAN IVM OVERHEAD

         IF (MOD(LOOP,1000).EQ.0) THEN

            TDUMP=CPTIME()-DTIMER
            IF (TDUMP.GT.DTIME) THEN

               KDUMP=KDUMP+1
               IF (KDUMP.GT.NFDUMP) KDUMP=1
               PRINT *,'DUMP OP FILE ',FDUMP(KDUMP)
               CALL DUMP(SPACE,IPACE,BUUR,T,LL,STNR,PRSTCK,AANTAL,
     +                   STACK,SYMS,IANTAL,FDUMP(KDUMP))

               DTIMER=CPTIME()

            ENDIF
         ENDIF
         LOOP=LOOP+1

         IF(MOD(LOOP,PRLOOP).EQ.0) THEN

            TTT=CPTIME()-TIMER
            WRITE(IU,2011) LOOP,NBINGO,NR,NEIND-NBEGIN+1,TTT
            WRITE(ISCRA,2011) LOOP,NBINGO,NR,NEIND-NBEGIN+1,TTT
 2011       FORMAT(1X,I10,I6,I4,I6,F10.2)
            IF (TTT.GE.TMAX) THEN
               CALL BINGO(PRSTCK,T,STNR,NR,IU,N123,NBINGO,LOOP,TTT)
               CALL BINGO(PRSTCK,T,STNR,NR,ISCRA,N123,NBINGO,LOOP,TTT)
               TIMER0=TIMER
               CPT0=CPTIME()
               CALL LTMAX
               IF (TMAX.LE.0) THEN
C DEBUG
                  PRINT *,'CALL DUMP'
                  KDUMP=KDUMP+1
                  IF (KDUMP.GT.NFDUMP) KDUMP=1
                  PRINT *,'DUMP OP FILE ',FDUMP(KDUMP)
                  CALL DUMP(SPACE,IPACE,BUUR,T,LL,STNR,PRSTCK,AANTAL,
     +                      STACK,SYMS,IANTAL,FDUMP(KDUMP))
                  WRITE(IU,*) 'NTMAX IS ',NTMAX,' GEBRUIKT: ',NTMAX1
                  WRITE(ISCRA,*) 'NTMAX IS ',NTMAX,' GEBRUIKT: ',NTMAX1
                  CALL STOPPEN
               ENDIF
               TTT=CPTIME()
               DTIMER=DTIMER+TTT-CPT0
               TIMER=TIMER0+TTT-CPT0
               TMAX=TMAX+CPT0-TIMER0
            ENDIF
         ENDIF

 2030    CONTINUE

         IF(STATUS.EQ.VOLGSM) GOTO 2050
         IF(STATUS.EQ.VOLGST) GOTO 2100
         IF(STATUS.EQ.TERUG)  GOTO 5300
         IF(STATUS.EQ.STOPPE) GOTO 5500

         PRINT *,'ONGELDIGE WAARDE VAN STATUS: ',STATUS
         CALL STOPPEN

C
C VOLGSM
C
C VERWIJDER LAATST GEPLAATSTE STEEN UIT SPACE

 2050    CONTINUE
         DO 2060 I=1,NKUB
C DEBUG
            IF(SPACE(T(NPROB,I)).NE.-1) THEN
               PRINT *,'FOUTJE IN VOLGSM'

               CALL BINGO(PRSTCK,T,STNR,NR,IU,N123,NBINGO,LOOP,TTT)
               PRINT *
               CALL PRSPACE(SPACE,N123)
               PRINT *,'VERDER NA RETURN'
               READ *
            ENDIF

C END DEBUG
            SPACE(T(NPROB,I))=1
 2060    CONTINUE
         STATUS=VOLGST
         GOTO 2000

C EINDE VOLGSM

C
C VOLGST
C

 2100    CONTINUE

C
C KIES DE VOLGENDE SYMMETRIE EQUIVALENT
C
 2105    CONTINUE

         NPROB=NPROB+1

         IF(NPROB .GE. NBEGIN1) THEN
            STATUS=TERUG
            GOTO 2000
         ENDIF

         IF(LL(NPROB).EQ.0) GOTO 2105
         PRSTCK(NR)=NPROB
         IF(NS1.GT.1) CALL TESTEQ(T,LL,SYMS,NPROB,NBEGIN1-1,NS1,NS2)

C CHECK, OF DE OVERGEBLEVEN VRIJE RUIMTES ELK EEN VEELVOUD VAN
C NSTEEN AANEENGESLOTEN CELLEN BEVATTEN.
C HIERTOE IN SPACE CODEREN MET -1, WELKE CELLEN BEZET ZIJN,
C EN TESTNS AANROEPEN.

         DO 2110 I=1,NKUB
            SPACE(T(NPROB,I))=-1
 2110    CONTINUE

         IF (TESTNS(SPACE,BUUR,N123).NE.0) THEN
            STATUS=VOLGSM
            GOTO 2000
         ENDIF

         DO 2200 I=NR+1,NSTEEN
            BANTAL(I)=AANTAL(I)
 2200    CONTINUE


         IF(NR.GE.PRBING .OR.NR.GT.NRMAX) THEN
            NRMAX=MAX(NRMAX,NR)
            TTT=CPTIME()-TIMER
            CALL BINGO(PRSTCK,T,STNR,NR,IU,N123,NBINGO,LOOP,TTT)
            CALL BINGO(PRSTCK,T,STNR,NR,ISCRA,N123,NBINGO,LOOP,TTT)
         ENDIF

         K=NBEGIN1
         DO 2300 I=NR+1,NSTEEN
            IANTAL(STNR(K))=I
            K=K+AANTAL(I)
 2300    CONTINUE

C
C MARKEER STENEN, DIE POSITIES GEMEENSCHAPPELIJK HEBBEN MET
C STEEN NPROB MARKEREN MET 0.
C
         DO 2400 I=NBEGIN1,NEIND
            LL(I)=1
 2400    CONTINUE

C
C ALS METHOD = 1: SCALAIR, ALS METHOD = 2: VECTOR
C

         IF (METHOD.EQ.1) THEN

            DO 2700 J=1,NKUB
               TNJ=T(NPROB,J)
               DO 2600 K=1,NKUB
                  DO 2500 I=NBEGIN1,NEIND
                     IF(T(I,K).EQ.TNJ) THEN
                        IF(LL(I).NE.0) THEN
                           STNRI=IANTAL(STNR(I))

C
C ALS EEN BANTAL .LE.1, DAN KAN DEZE POGING VERDER WORDEN GESKIPT
C
                           IF(BANTAL(STNRI).LE.1) THEN
                              STATUS=VOLGSM
                              GOTO 2000
                           ENDIF
                           LL(I)=0
                           BANTAL(STNRI)=BANTAL(STNRI)-1
                        ENDIF
                     ENDIF
 2500             CONTINUE
 2600          CONTINUE
 2700       CONTINUE

         ELSE

            DO 3000 J=1,NKUB
               TNJ=T(NPROB,J)
               DO 2900 K=1,NKUB

C
C LL(I) MOET NUL WORDEN, WAAR T(I,K).EQ.TNJ. DE GEBRUIKTE CONSTRUKTIE
C VECTORISEERT. DE EENVOUDIGER VARIANT:
                  DO 2800 I=NBEGIN1,NEIND
                     IF(T(I,K).EQ.TNJ) LL(I)=0
 2800             CONTINUE
C VECTORISEERT (NOG) NIET ONDER FORTVS2 (IBM)
C
c            DO 2800 I=NBEGIN1,NEIND
c              LL(I)=MIN(LL(I),ABS(T(I,K)-TNJ))
c 2800       CONTINUE

 2900          CONTINUE
 3000       CONTINUE

C
C NOTEER IN LSTNR DE NUMMERS VAN DE STENEN, DIE WEGVALLEN
C

            NLSTNR=0
            DO 3100 I=NBEGIN1,NEIND
               IF(LL(I).EQ.0) THEN
                  NLSTNR=NLSTNR+1
                  LSTNR(NLSTNR)=STNR(I)
               ENDIF
 3100       CONTINUE

C
C NU HET AANPASSEN VAN BANTAL. HIERVOOR GEBRUIKEN WE
C ARRAY LSTNR: DIT BEVAT DE INDEXEN VAN DE BANTALLEN DIE
C MET EEN MOETEN WORDEN VERLAAGD.
C

            DO 3200 I=1,NLSTNR
               K=IANTAL(LSTNR(I))
               BANTAL(K)=BANTAL(K)-1
 3200       CONTINUE

C
C ALS EEN BANTAL .LE. 0, DAN KUNNEN WE DEZE POGING VERDER
C SKIPPEN
C
            DO 3300 I=NR+1,NSTEEN
               IF(BANTAL(I).LE.0) THEN
                  STATUS=VOLGSM
                  GOTO 2000
               ENDIF
 3300       CONTINUE

         ENDIF

C
C ALS NR IS NSTEEN, DAN IS OPLOSSING GEVONDEN
C
         IF (NR .EQ. NSTEEN) THEN
            NBINGO=NBINGO+1
            TTT=CPTIME()-TIMER
            CALL BINGO(PRSTCK,T,STNR,NR,IU,N123,NBINGO,LOOP,TTT)
            CALL BINGO(PRSTCK,T,STNR,NR,ISCRA,N123,NBINGO,LOOP,TTT)
            CALL BINGO(PRSTCK,T,STNR,NR,IOPLOS,N123,NBINGO,LOOP,TTT)

            STATUS=VOLGSM
            GOTO 2000
         ENDIF

C
C TEST OF ALLE STENEN NOG GEPLAATST KUNNEN WORDEN:
C NSTEEN*NKUB POSITIES MOETEN KUNNEN WORDEN GEVULD MET
C DE OVERGEBLEVEN STENEN. IN TPACE WORDEN HET AANTAL
C MOGELIJKHEDEN GETELD OM EEN STEEN OP EEN POSITIE TE
C PLAATSEN. DEZE GETALLEN WORDEN GEBRUIKT OM:
C
C -A TE ZIEN OF DE OVERGEBLEVEN RUIMTE GEVULD KAN WORDEN
C    MET DE REST VAN DE STENEN
C -B TE ZIEN OF ER EEN GEDWONGEN ZET IS (VANDAAR NOTATIE
C    IN UPACE VAN RANGNUMMER VAN GEDWONGEN STEEN)
C

         DO 3400 I=1,LSPACE
            TPACE(IPACE(I))=0
 3400    CONTINUE

         DO 3600 I=1,NKUB
            DO 3500 J=NBEGIN1,NEIND
               IF(LL(J).NE.0) THEN
                  TPACE(T(J,I))=TPACE(T(J,I))+1
                  UPACE(T(J,I))=J
               ENDIF
 3500       CONTINUE
 3600    CONTINUE

         SOM=NR*NKUB
         DO 3700 I=1,LSPACE
            SOM=SOM+MIN(1,TPACE(IPACE(I)))
 3700    CONTINUE

         IF(SOM.LT.NKS) THEN
            STATUS=VOLGSM
            GOTO 2000
         ENDIF

         NSTACK=NSTACK+1
         STACK(NSTACK)=NBEGIN

         NSTACK=NSTACK+1
         STACK(NSTACK)=NBEGIN1

         NSTACK=NSTACK+1
         STACK(NSTACK)=NEIND

         NSTACK=NSTACK+1
         STACK(NSTACK)=NPROB

         NSTACK=NSTACK+1
         STACK(NSTACK)=NS1

         DO 3800 I=NR+1,NSTEEN
            NSTACK=NSTACK+1
            STACK(NSTACK)=AANTAL(I)
 3800    CONTINUE

         IF(NEIND+NEIND-NBEGIN1.GT.NTMAX) THEN
            PRINT *,'NTMAX IS ',NTMAX,' DAT IS TE KLEIN'
            CALL STOPPEN
         ENDIF

C
C ONDERZOEK, OF ER EEN GEDWONGEN ZET IS, EEN ELEMENT VAN
C TPACE IS DAN 1. ZO JA, PAS DAN BIJBEHORENDE BANTAL AAN
C (ZET HEM OP EEN) EN ZET DE ANDERE LL'EN DIE BIJ DE STEEN
C HOREN OP NUL. HIERDOOR KOMT DEZE STEEN IN AANMERKING
C OM ALS EERSTE GEPLAATST TE WORDEN.
C DEZE TRUC WERKT ALLEEN, ALS NSTEEN*NKUB .EQ. LSPACE
C
         IF(NSTEEN*NKUB.EQ.LSPACE) THEN

            DO 3860 I=1,LSPACE
               IF(TPACE(IPACE(I)).EQ.1) THEN

                  K=UPACE(IPACE(I))
                  LB=NBEGIN1

                  DO 3820 J=NR+1,IANTAL(STNR(K))-1
                     LB=LB+AANTAL(J)
 3820             CONTINUE

                  DO 3830 J=LB,LB+AANTAL(IANTAL(STNR(K)))-1
                     LL(J)=0
 3830             CONTINUE

                  LL(K)=1
                  BANTAL(IANTAL(STNR(K)))=1
                  GOTO 3861

               ENDIF
 3860       CONTINUE
 3861       CONTINUE

         ENDIF
C
C ZOEK LAAGSTE BANTAL, DEZE KOMT ALS EERSTE IN DE RIJ
C
         L=NEIND+1
         DO 3900 I=NR+1,NSTEEN
            IF(BANTAL(I).LT.L) THEN
               L=BANTAL(I)
               K=I
            ENDIF
 3900    CONTINUE
         LA=AANTAL(K)

C
C COPIEER BIJBEHORENDE STENEN NAAR EINDE T-ARRAY, BEPAAL EERST
C BEGIN EN EIND INDEXEN (LB,LE)
C (LET EVEN OP GEBRUIK VAN AANTAL IPV BANTAL)
C
         LB=NBEGIN1
         DO 4000 I=NR+1,K-1
            LB=LB+AANTAL(I)
 4000    CONTINUE
         LE=LB+LA-1

C
C PAS BANTAL AAN
C
         DO 4100 I=K,NR+2,-1
            BANTAL(I)=BANTAL(I-1)
 4100    CONTINUE
         BANTAL(NR+1)=L

         DO 4300 J=1,NKUB
            K=NEIND
            DO 4200 I=LB,LE
               IF(LL(I).NE.0) THEN
                  K=K+1
                  T(K,J)=T(I,J)
               ENDIF
 4200       CONTINUE
 4300    CONTINUE

         K=NEIND
         DO 4400 I=LB,LE
            IF(LL(I).NE.0) THEN
               K=K+1
               STNR(K)=STNR(I)
C
C MARKEER STENEN, ZODAT ZE STRAKS NIET NOG EENS GECOPIEERD WORDEN
C
               LL(I)=0
            ENDIF
 4400    CONTINUE

         KK=K
C
C COPIEREN VAN NIET GEMARKEERDE STENEN NAAR EINDE T ARRAY
C

         DO 4600 J=1,NKUB
            K=KK
C
C DE VOLGENDE LOOP IS EEN GATHER OPERATIE, ZONDER OVERLAP
C
            DO 4500 I=NBEGIN1,NEIND
               IF (LL(I).NE.0) THEN
                  K=K+1
                  T(K,J)=T(I,J)
               ENDIF
 4500       CONTINUE
 4600    CONTINUE

         K=KK
         DO 4700 I=NBEGIN1,NEIND
            IF(LL(I).NE.0) THEN
               K=K+1
               STNR(K)=STNR(I)
            ENDIF
 4700    CONTINUE

         NBEGIN=NEIND+1
         NEIND=K

         NBEGIN1=NBEGIN+BANTAL(NR+1)
         NTMAX1=MAX(NTMAX1,NEIND)

         DO 5000 I=NR+1,NSTEEN
            AANTAL(I)=BANTAL(I)
 5000    CONTINUE

C
C DEBUG
C
         CALL CHAANT(T,STNR,NBEGIN,NEIND,AANTAL,NR+1,13,'FACODUMP')

C
C STEEN PAST, NU DE VOLGENDE PROBEREN
C
         NPROB=NBEGIN-1
         NR=NR+1
         NS1=NS2
         STATUS=VOLGST

         DO 5030 I=NBEGIN,NBEGIN1-1
            LL(I)=1
 5030    CONTINUE
         GOTO 2000

C
C EINDE VOLGST
C

C
C TERUG
C

 5300    CONTINUE

         IF(NR.EQ.1) THEN
            STATUS=STOPPE
            GOTO 2000
         ENDIF

         NR=NR-1

         DO 5400 I=NSTEEN,NR+1,-1
            AANTAL(I)=STACK(NSTACK)
            NSTACK=NSTACK-1
 5400    CONTINUE

         NS1=STACK(NSTACK)
         NSTACK=NSTACK-1

         NPROB=STACK(NSTACK)
         NSTACK=NSTACK-1

         NEIND=STACK(NSTACK)
         NSTACK=NSTACK-1

         NBEGIN1=STACK(NSTACK)
         NSTACK=NSTACK-1

         NBEGIN=STACK(NSTACK)
         NSTACK=NSTACK-1

         STATUS=VOLGSM
         GOTO 2000

C
C EINDE STATUS=TERUG
C

C
C STATUS = STOPPE
C
 5500    CONTINUE
         WRITE(IU,*) ' EINDE VAN ALLE MOGELIJKHEDEN BEREIKT'
         CALL STOPPEN
      END

      SUBROUTINE MSYM(SYMOP,NSYM0,NSYM,NSYMMAX)
C
C GENEREERT ALLE SYMMETRIE OPERATIES, UITGAANDE VAN DE NSYM0
C OPERATIES IN SYMOP
C DE OPERATIES WORDEN IN ARRAY SYMOP GENOTEERD, TOTALE AANTAL
C WORDT NSYM
C
C SYMOP IN: GEGEVEN NSYM0 SYMMETRIEOPERATIES
C       UIT: ALLE MOGELIJKE OPERATIES
C NSYM0 IN: AANTAL GEGEVEN OPERATIES
C NSYM  UIT: TOTAAL AANTAL SYMMETRIE OPERATIES
C NSYMMAX IN: GROOTTE VAN ARRAY SYMOP MOET MINIMAAL 1 PLUS
C             TOTAAL AANTAL SYMMETRIE OPERATIES ZIJN
C
         IMPLICIT INTEGER (A-Z)
         DIMENSION SYMOP(3,NSYMMAX)
         LOGICAL MEER
         ISTART=2
         IEIND=NSYM0
         NSYM=NSYM0
   10    CONTINUE
         MEER=.FALSE.
         DO 100 I=2,NSYM0
            DO 80 J=ISTART,IEIND
               CALL GENSYM(SYMOP(1,I), SYMOP(1,J), SYMOP(1,NSYM+1))
               DO 40 K=1,NSYM
                  IF (SYMOP(1,NSYM+1).EQ.SYMOP(1,K)) THEN
                     IF (SYMOP(2,NSYM+1).EQ.SYMOP(2,K)) THEN
                        IF (SYMOP(3,NSYM+1).EQ.SYMOP(3,K)) THEN
                           GOTO 45
                        ENDIF
                     ENDIF
                  ENDIF
   40          CONTINUE
               NSYM = NSYM+1
               MEER = .TRUE.
               IF (NSYM.GE.NSYMMAX) THEN
                  PRINT *,'NSYM = ',NSYM,' PROGRAMMA STOPT'
                  CALL STOPPEN
               ENDIF
   45          CONTINUE
   80       CONTINUE
  100    CONTINUE

         IF (MEER) THEN
            ISTART=IEIND+1
            IEIND=NSYM
            GOTO 10
         ENDIF
         RETURN
      END


      SUBROUTINE GENSYM(S1,S2,S3)
C
C PAST SYMMETRIE OPERATIE S1 OP SYMMETRIE OPERATIE S2 TOE
C UITKOMST IN S3
C
         IMPLICIT INTEGER(A-Z)
         DIMENSION S1(3),S2(3),S3(3)
         DO 10 I=1,3
            S3(I)=S2(ABS(S1(I)))*SIGN(1,S1(I))
   10    CONTINUE
         RETURN
      END

      SUBROUTINE SYMSPA(SYMOP,SYMS,NSYM,NSYMS,SPACE,N123)

C ZOEKT UIT, WELKE SYMMETRIE OPERATIES SPACE ONGEWIJZIGD LATEN,
C INPUT: SYMOP(3,NSYM): DE SYMMETRIE OPERATIES
C        NSYM AANTAL INPUT SYMMETRIE OPERATIES
C        SPACE: ZIE SUBROUTINE MSPACE
C        N123:  DIMENSIE VAN SPACE
C OUTPUT: SYMS(3,NSYMS): DE SYMMETRIE OPERATIES, DIE SPACE ONVERANDERD
C         LATEN
C
C METHODE: PAS ALLE SYMMETRIE OPERATIES TOE OP SPACE, EN NOTEER
C          WELKE SPACE IN ZICHZELF OVERVOEREN
C          SPIEGELING IN EEN DIMENSIE DIE EEN IS, IS GEEN OVERVOERING
C          IN ZICHZELF

         IMPLICIT INTEGER(A-Z)
         DIMENSION SYMOP(3,NSYM)
         DIMENSION SYMS(3,NSYM)
         DIMENSION SPACE(N123)
         DIMENSION XX(3),XX1(3)
         COMMON /BLOCK/ NN(3)

         NSYMS=0

C LOOP OVER ALLE SYMMETRIE OPERATIES

         DO 1000 I=1,NSYM

C EERST EVEN ENKELE  SNELLE CONTROLES

            DO 40 J=1,3

C DIMENSIES MOETEN ONVERANDERD BLIJVEN

               IF(NN(J).NE.NN(ABS(SYMOP(J,I)))) GOTO 900

C SPIEGELING IN DIMENSIE EEN SKIPPEN:

               IF(NN(J).EQ.1 .AND. SYMOP(J,I).LT.0) GOTO 900
   40       CONTINUE

            K=0

C GENEREER SYMMETRIE EQUIVALENT VAN ELKE CEL, EN KIJK OF
C DE INHOUD HETZELFDE IS

            DO 200 Z=0,NN(3)-1
               DO 190 Y=0,NN(2)-1
                  DO 180 X=0,NN(1)-1
                     K=K+1
                     XX(1)=X
                     XX(2)=Y
                     XX(3)=Z
                     DO 140 J=1,3
                        XX1(J)=XX(ABS(SYMOP(J,I)))
                        IF(SYMOP(J,I).LT.0) XX1(J)=NN(J)-XX1(J)-1
  140                CONTINUE

C K1 WORDT DE INDEX VAN DE SYMMETRIE GERELATEERDE CEL

                     K1=1+XX1(1)+NN(1)*(XX1(2)+NN(2)*XX1(3))
C DEBUG
                     IF(K1.LE.0 .OR. K1.GT.N123) THEN
                        PRINT *,'N123 =',N123
                        PRINT *,'K1 =',K1
                        PRINT *,'XYZ =',X,Y,Z
                        STOP
                     ENDIF

                     IF(SPACE(K).NE.SPACE(K1)) GOTO 900

  180             CONTINUE
  190          CONTINUE
  200       CONTINUE

C OP DIT PUNT IS EEN SYMMETRIE OPERATIE GEVONDEN, DIE SPACE
C IN ZICHZELF OVERVOERT

            NSYMS=NSYMS+1
            DO 500 J=1,3
               SYMS(J,NSYMS)=SYMOP(J,I)
  500       CONTINUE

            GOTO 1000
  900       CONTINUE
 1000    CONTINUE
         RETURN
      END


      SUBROUTINE DECO(N,X)

C BEREKENT XYZ COORDINATEN UIT POSITIE
C INPUT: N: POSITIE
C OUTPUT: X(3): XYZ COORDINATEN (0..NN(1..3))

         IMPLICIT INTEGER(A-Z)
         DIMENSION X(3)
         COMMON /BLOCK/ NN(3)
         A=(N-1)/NN(1)
         X(1)=(N-1)-NN(1)*A
         X(3)=A/NN(2)
         X(2)=A-X(3)*NN(2)
         RETURN
      END


      SUBROUTINE SYMP(S, P1, P2)
C
C PAST SYMMETRIE OPERATIE S OP POSITIES IN P1 TOE. UITKOMST IN P2
C
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NKUB=5)
         DIMENSION S(3),P1(3,NKUB),P2(3,NKUB)
         DO 100 I=1,NKUB
            DO 80 J=1,3
               P2(J,I)=SIGN(1,S(J))*P1(ABS(S(J)),I)
   80       CONTINUE
  100    CONTINUE
         RETURN
      END


      SUBROUTINE BSORT(A,N)
C
C SORTEERT ARRAY A(N) VOLGENS BUBBLESORT ALGORITME, VAN HOOG NAAR LAAG
C
         INTEGER A(N)
         LOGICAL SORTED
         INTEGER I,K
         INTEGER T
         IF (N.LE.1) RETURN
         K=N-1
   10    CONTINUE
         SORTED=.TRUE.
         DO 100 I=1,K
            IF (A(I).LT.A(I+1)) THEN
               T=A(I)
               A(I)=A(I+1)
               A(I+1)=T
               K=I
               SORTED=.FALSE.
            ENDIF
  100    CONTINUE
         IF (.NOT.SORTED) GOTO 10
         RETURN
      END

      SUBROUTINE BBSORT(A)
         IMPLICIT INTEGER (A-Z)
C
C SORTEERT ARRAY A(3,NKUB) (STEEN COORDINATEN) VOLGENS BUBBLESORT ALGORITME
C
         PARAMETER(NKUB=5)
         DIMENSION A(3,NKUB)
         LOGICAL SORTED
         K=NKUB-1
   10    CONTINUE
         SORTED=.TRUE.
         DO 100 I=1,K
            DO 20 J=1,3
               IF (A(J,I).GT.A(J,I+1)) GOTO 50
               IF (A(J,I).LT.A(J,I+1)) GOTO 100
   20       CONTINUE
            GOTO 100
   50       CONTINUE
            DO 60 J=1,3
               T=A(J,I)
               A(J,I)=A(J,I+1)
               A(J,I+1)=T
   60       CONTINUE
            K=I
            SORTED=.FALSE.
  100    CONTINUE
         IF (.NOT.SORTED) GOTO 10
         RETURN
      END

      SUBROUTINE GENPOS(S,GS,NGS,SYMOP,NSYM)
C
C GENEREERT IN ARRAY GS ALLE SYMMETRIE EQUIVALENTEN VAN
C STEEN S.
C INPUT: S(3,NKUB) STEEN POSITIES
C        SYMOP(3,NSYM): SYMMETRIE OPERATIES
C        NSYM: AANTAL SYMMETRIE OPERATIES
C OUTPUT: GS(3,NKUB,NGS) DE SYMMETRIE EQUIVALENTE STEEN POSITIES
C         DUBBELE ZIJN GEELIMINEERD
C         NGS: AANTAL EQUIVALENTE POSITIES
C
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NKUB=5)
         PARAMETER(NGSMAX=24)
         DIMENSION S(3,NKUB),GS(3,NKUB,NGSMAX),SYMOP(3,NSYM)
         DIMENSION P(3,NKUB)

         NGS=0
         DO 100 I=1,NSYM
C
C I-LOOP OVER SYMMETRIE OPERATIES
C
C GENEREER I-DE SYMMETRIE EQUIVALENT
C
            CALL SYMP(SYMOP(1,I),S,P)
C
C BRENG COORDINATEN IN STANDAARDVORM OM VERGELIJKEN MET
C REEDS GEVONDEN COORDINATEN MOGELIJK TE MAKEN
C SORTEREN:
C
            CALL BBSORT(P)
C
C LEG EERSTE STEEN OP 0,0,0
C
            DO 10 J=2,NKUB
               DO 10 K=1,3
                  P(K,J)=P(K,J)-P(K,1)
   10       CONTINUE
            DO 12 K=1,3
               P(K,1)=0
   12       CONTINUE
C
C L-LOOP OVER REEDS GEVONDEN POSITIES OM TE CONTROLEREN OF DE
C GEVONDEN POSITIE NIEUW IS
C
            DO 40 L=1,NGS
               DO 30 J=1,NKUB
                  DO 20 K=1,3
                     IF (P(K,J) .NE. GS(K,J,L)) GOTO 40
   20             CONTINUE
   30          CONTINUE
C
C OP DIT PUNT AANGELAND HOUDT IN, DAT EEN AL GEVONDEN POSITIE
C IS GEVONDEN. GA DOOR MET VOLGENDE SYMMETRIE OPERATIE
C
               GOTO 100
   40       CONTINUE
C
C EEN NIEUWE POSITIE IS GEVONDEN, VOEG HEM TOE
C
            NGS=NGS+1
            IF(NGS .GT. NGSMAX) THEN
               PRINT *,'WAARDE NGSMAX (',NGSMAX,') IS TE KLEIN'
               CALL STOPPEN
            ENDIF
            DO 60 J=1,NKUB
               DO 60 K=1,3
                  GS(K,J,NGS)=P(K,J)
   60       CONTINUE
  100    CONTINUE
         RETURN
      END

      SUBROUTINE MSPACE(SPACE,IPACE,LSPACE,N123)
C
C VULT SPACE MET NULLEN, WAAR GEEN STENEN MOETEN KOMEN
C MET ENEN, WAAR STENEN MOETEN KOMEN
C LSPACE WORDT AANTAL ENEN
C IPACE WORDT INDEXEN VAN ENEN IN SPACE
C N123 WORDT INHOUD VAN OMHULLENDE BLOK (NN(1)*NN(2)*NN(3))
C
C ADRESSERING VAN SPACE: INDIEN SPACE ALS DRIEDIMENSIONAAL
C BLOK WORDT BESCHREVEN: SPACE(I,J,K), DAN GELDT:
C SPACE(I,J,K)=SPACE(1+I+NN(1)*(J+NN(2)*K)),
C I=0..NN(1)-1, J=0..NN(2)-1, K=0..NN(3)-1
C
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NSPACE=200)
         PARAMETER(NSTEEN=12)
         PARAMETER(NKUB=5)
         PARAMETER(NKS=NKUB*NSTEEN)
         COMMON /BLOCK/ NN(3)
         DIMENSION SPACE(NSPACE),IPACE(NSPACE)
         DO 5 I=1,NSPACE
            SPACE(I)=0
    5    CONTINUE
         PRINT *,'N1 N2 N3 AUB..'
         READ *,NN(1),NN(2),NN(3)
         CALL BSORT(NN,3)
         PRINT *,'N1 N2 N3 :',NN(1),NN(2),NN(3)
         N123=NN(1)*NN(2)*NN(3)
         PRINT *,'INHOUD BLOK IS: ',N123

         IF (N123.GT.NSPACE) THEN
            PRINT *,'NSPACE IS ',NSPACE,' DAT IS TE KLEIN'
            CALL STOPPEN
         ENDIF

         DO 40 I=1,N123
            SPACE(I)=1
   40    CONTINUE


         LSPACE=0
         DO 500 I=1,N123
            IF(SPACE(I).NE.0) THEN
               LSPACE=LSPACE+1
               IPACE(LSPACE)=I
            ENDIF
  500    CONTINUE

         IF(LSPACE.NE.NKS) THEN
            PRINT *,'AANTAL CELLEN IS ',LSPACE
            PRINT *,'MOET ECHTER ZIJN ',NKS
            CALL STOPPEN
         ENDIF

         RETURN
      END

      SUBROUTINE PRSPACE(SPACE,N123)
         IMPLICIT INTEGER(A-Z)
         COMMON /BLOCK/ NN(3)
         DIMENSION SPACE(N123)
         CHARACTER*1 A(80)
         DO 100 J=0,NN(2)-1
            DO 30 Z=1,80
               A(Z)=' '
  30        CONTINUE
            P=1
            DO 90 K=0,NN(3)-1
               P=P+2
               DO 50 I=0,NN(1)-1
                  Q=1+I+NN(1)*(J+NN(2)*K)
                  IF (SPACE(Q).EQ.0) A(P)='*'
                  IF (SPACE(Q).EQ.1) A(P)='.'
                  IF(SPACE(Q).EQ.2) A(P)='M'
                  IF(SPACE(Q).EQ.-1) A(P)='@'
                  P=P+2
   50          CONTINUE
   90       CONTINUE
            PRINT *,(A(Z),Z=1,P)
  100    CONTINUE
         RETURN
      END

      SUBROUTINE MBUUR(SPACE,N123,BUUR)
C
C BEPAALT BUREN VAN CELLEN
C INPUT: SPACE(N123)
C OUTPUT:  BUUR(6,N123)
C          BUUR(1..6,I) GEEFT DE BUREN VAN CEL I AAN.
C                       BUUR(N,I)=0, INDIEN N-1 BUREN (N<= 6)
C
         IMPLICIT INTEGER(A-Z)
         COMMON /BLOCK/ NN(3)
         DIMENSION SPACE(N123),BUUR(6,N123)

         DO 100 I=1,N123
            DO 80 J=1,6
               BUUR(J,I)=0
   80       CONTINUE
  100    CONTINUE
         P=0
         DO 200 K=0,NN(3)-1
            DO 190 J=0,NN(2)-1
               DO 180 I=0,NN(1)-1
                  P=P+1
C
C P IS STEEDS GELIJK AAN: 1+I+NN(1)*(J+NN(2)*K)
C
                  IF(SPACE(P).NE.0) THEN
                     BUUR(1,P)=P
                     L=0
                     IF(I+1.LT.NN(1)) THEN
                        Q=P+1
                        IF(SPACE(Q).NE.0) THEN
                           L=L+1
                           BUUR(L,P)=Q
                        ENDIF
                     ENDIF
                     IF(I.GT.0) THEN
                        Q=P-1
                        IF(SPACE(Q).NE.0) THEN
                           L=L+1
                           BUUR(L,P)=Q
                        ENDIF
                     ENDIF
                     IF(J+1.LT.NN(2)) THEN
                        Q=P+NN(1)
                        IF(SPACE(Q).NE.0) THEN
                           L=L+1
                           BUUR(L,P)=Q
                        ENDIF
                     ENDIF
                     IF(J.GT.0) THEN
                        Q=P-NN(1)
                        IF(SPACE(Q).NE.0) THEN
                           L=L+1
                           BUUR(L,P)=Q
                        ENDIF
                     ENDIF
                     IF(K+1.LT.NN(3)) THEN
                        Q=P+NN(1)*NN(2)
                        IF(SPACE(Q).NE.0) THEN
                           L=L+1
                           BUUR(L,P)=Q
                        ENDIF
                     ENDIF
                     IF(K.GT.0) THEN
                        Q=P-NN(1)*NN(2)
                        IF(SPACE(Q).NE.0) THEN
                           L=L+1
                           BUUR(L,P)=Q
                        ENDIF
                     ENDIF
                  ENDIF
  180          CONTINUE
  190       CONTINUE
  200    CONTINUE

         RETURN
      END

      SUBROUTINE ALLPOS(LS,GS,NGS,T,NT,STNR,SPACE,N123)
C
C GENEREERT ALLE MOGELIJKE POSITIES VAN DE STENEN IN GS
C DE POSITIES KOMEN IN ARRAY T
C
C INPUT PARAMETERS:
C    LS: STEENNUMMER
C    GS(3,NKUB,NGS): DE NGS SYMMETRIE EQUIVALENTE STEENPOSITIES
C    NGS: AANTAL SYMMETRIE EQUIVALENTE STEENPOSITIES
C    SPACE(N123): ARRAY GEVULD DOOR MSPACE
C OUTPUT PARAMETERS:
C    T(NTMAX,NKUB): DE STEENPOSITIES
C    STNR(NTMAX):   DE BIJBEHORENDE STEENNUMMERS
C    NT: TOTAAL AANTAL POSITIES, NT WORDT STEEDS OPGEHOOGD
C
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NKUB=5)
         PARAMETER(NTMAX=15000)
         COMMON /BLOCK/ NN(3)
         DIMENSION GS(3,NKUB,NGS)
         DIMENSION SPACE(N123)
         DIMENSION T(NTMAX,NKUB)
         DIMENSION STNR(NTMAX)
         DIMENSION M(NKUB)
C
C LOOP OVER ALLE SYMMETRIE EQUIVALENTEN
C
         DO 200 N=1,NGS
C
C LOOPS OVER ALLE POSITIES IN SPACE
C
            DO 100 I=0,NN(1)-1
               DO 100 J=0,NN(2)-1
                  DO 100 K=0,NN(3)-1
C
C ALS STEEN BUITEN GRENZEN VAN SPACE VALT OF BETREFFENDE
C ELEMENT VAN SPACE BUITEN TE VULLEN BLOK VALT, SKIP DE
C GEVONDEN POSITIE
C
                     DO 30 L=NKUB,1,-1
                        X=GS(1,L,N)+I
                        IF(X.GE.NN(1)) GOTO 100
                        IF(X.LT.0)  GOTO 100
                        Y=GS(2,L,N)+J
                        IF(Y.GE.NN(2)) GOTO 100
                        IF(Y.LT.0)  GOTO 100
                        Z=GS(3,L,N)+K
                        IF(Z.GE.NN(3)) GOTO 100
                        IF(Z.LT.0)  GOTO 100
                        ML=1+X+NN(1)*(Y+NN(2)*Z)
                        IF(SPACE(ML).EQ.0) GOTO 100
                        M(L)=ML
   30                CONTINUE
C
C HIER IS EEN GELDIGE NIEUWE POSITIE GEVONDEN, VERHOOG NT
C EN NOTEER DE STEENPOSITIE IN T
C
                     NT=NT+1
                     IF(NT.GT.NTMAX)THEN
                        PRINT *,'NTMAX TE KLEIN ',NTMAX
                        CALL STOPPEN
                     ENDIF

C SORTEER COORDINATEN (KOMT LATER NOG VAN PAS)

                     CALL BSORT(M,NKUB)
                     DO 50 L=1,NKUB
                        T(NT,L)=M(L)
   50                CONTINUE
                     STNR(NT)=LS
  100       CONTINUE
  200    CONTINUE
         RETURN
      END

      SUBROUTINE BINGO(PRSTCK,T,STNR,NR,IU,N123,NBINGO,LOOP,TTT)
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NSTEEN=12)
         PARAMETER(NKUB=5)
         PARAMETER(NTMAX=15000)
         PARAMETER(RMAX=200)
         PARAMETER(NSPACE=200)
         COMMON /BLOCK/ NN(3)
         DIMENSION T(NTMAX,NKUB)
         DIMENSION STNR(NTMAX)
         DIMENSION PRSTCK(NSTEEN)
         DOUBLE PRECISION TTT
         CHARACTER*1 CSPACE(NSPACE)
         CHARACTER*(RMAX) REGEL
         CHARACTER*(NSTEEN) SNAAM
         CHARACTER*1 LLL
         DATA SNAAM /'YPNVTUXZWFIL'/
         DATA LLL /'.'/

         DO 10 I=1,N123
            CSPACE(I)=LLL
  10     CONTINUE

         DO 20 I=1,NR
            REGEL(I:I)=SNAAM(STNR(PRSTCK(I)):STNR(PRSTCK(I)))
  20     CONTINUE

         WRITE(IU,99) NBINGO,REGEL(1:NR),LOOP,TTT
   99    FORMAT(1X,I6,1X,A12,I10,F10.2)

         DO 100 I=1,NKUB
            DO 50 J=1,NR
               PJ=PRSTCK(J)
               CSPACE(T(PJ,I))=
     +                  SNAAM(STNR(PJ):STNR(PJ))
   50       CONTINUE
  100    CONTINUE

         DO 200 J=0,NN(2)-1
            R=0
            DO 190 I=0,NN(3)-1
               R=R+1
               REGEL(R:R+1)='  '
               R=R+1
               DO 180 K=0,NN(1)-1
                  R=R+1
                  REGEL(R:R)=CSPACE(1+K+NN(1)*(J+NN(2)*I))
                  R=R+1
                  REGEL(R:R)=' '
  180          CONTINUE
  190       CONTINUE
            WRITE(IU,*) REGEL(1:R)
  200    CONTINUE
         RETURN
      END


      SUBROUTINE CHAANT(T,STNR,NBEGIN,NEIND,AANTAL,M,ND,FNAAM)
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NSTEEN=12)
         PARAMETER(NKUB=5)
         PARAMETER(NKS=NKUB*NSTEEN)
         PARAMETER(NTMAX=15000)
         DIMENSION T(NTMAX,NKUB)
         DIMENSION AANTAL(NSTEEN)
         DIMENSION STNR(NTMAX)
         CHARACTER*(*) FNAAM
         P=M-1
         X=-1

         DO 1000 I=NBEGIN,NEIND
            IF(X.NE.STNR(I)) THEN
               IF(X.GT.0) THEN
                  IF (TEL.NE.AANTAL(P)) THEN
                     PRINT *,' FOUT IN AANTAL EN ZO'
                     PRINT *,' DUMP OP FILE ',FNAAM
                     OPEN(ND,FILE=FNAAM)
                     CLOSE(ND,STATUS='DELETE')
                     OPEN(ND,FILE=FNAAM)
                     WRITE(ND,*) 'AANTAL'
                     WRITE(ND,*) AANTAL
                     WRITE(ND,*) 'NBEGIN IS ',NBEGIN
                     WRITE(ND,*) 'NEIND  IS ',NEIND
                     WRITE(ND,*) 'AANTAL(',P,') IS FOUT, GEVONDEN ',TEL
                     WRITE(ND,*) 'INDEX IS ',I
                     DO 300 J=1,NEIND
                        WRITE(ND,'(12I6)') J,STNR(J),(T(J,K),K=1,NKUB)
  300                CONTINUE
                     CLOSE(ND)
                     CALL STOPPEN
                  ENDIF
               ENDIF
               P=P+1
               TEL=0
               X=STNR(I)
            ENDIF
            TEL=TEL+1
 1000    CONTINUE
         RETURN
      END


      FUNCTION TESTNS(SPACE,BUUR,N123)

C
C BEKIJKT, OF DE LEGE RUIMTES EEN VEELVOUD VAN NKUB CELLEN
C BEVATTEN. ZOJA: RETURNT 0 , ZONEE: RETURNT MOD(N,NKUB),WAARIN
C N HET AANTAL CELLEN IS IN DE LAATST ONDERZOCHTE VRIJE RUIMTE
C INPUT: SPACE(I)=-1: CEL I BEZET
C        SPACE(I)= 0: CEL I MAG NIET WORDEN BEZET
C        SPACE(I)= 1: CEL I IS VRIJ
C        BUUR(6,N123) ZIE SUBR MBUUR
C
C NA AFLOOP KAN DE INHOUD VAN SPACE DIE 1 WAS, VERANDERD ZIJN IN 2
C
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NSTEEN=12)
         PARAMETER(NKUB=5)
         PARAMETER(NKS=NKUB*NSTEEN)
         DIMENSION SPACE(N123)
         DIMENSION BUUR(6,N123)
         DIMENSION STACK(NKS)

C
C VERANDER 2 IN 1 IN SPACE:
C
C -1 -> -1
C  2 ->  1
C  1 ->  1
C  0 ->  0
C

         DO 10 I=1,N123
            SPACE(I)=MIN(SPACE(I),1)
   10    CONTINUE

         K=0
   50    CONTINUE

C ZOEK EERSTVOLGENDE LEGE, NIET GEMARKEERDE CEL OP

         DO 100 I=K+1,N123
            K=I
            IF(SPACE(I).EQ.1) GOTO 110
  100    CONTINUE

C GEEN LEGE, NIET GEMARKEERDE CEL GEVONDEN:

         TESTNS=0

         RETURN

  110    CONTINUE


C GEVONDEN LEGE CELLEN WORDEN OP LIFO STACK GEZET
C VAN DE CELLEN OP DE STACK WORDEN DE BUREN OP DE STACK GEZET,
C VOORZOVER UITERAARD DE CEL AL NIET OP DE STACK STAAT (CODE 2)
C OF DOOR EEN STEEN IS BEZET (CODE -1) OF NIET BEZET MAG WORDEN
C (CODE 0). IN TEL WORDT HET AANTAL AANEENSLUITENDE VRIJE
C CELLEN GETELD.

         TEL=1
         PTR=1
         STACK(PTR)=K
         SPACE(K)=2

  200    CONTINUE

C ALS PTR=0, DAN IS HET EINDE VAN DEZE VRIJE RUIMTE BEREIKT

         IF(PTR.EQ.0) THEN
            IF(MOD(TEL,NKUB).NE.0) THEN
               TESTNS=MOD(TEL,NKUB)
               RETURN
            ENDIF

C VINDT VOLGENDE DEELRUIMTE, ALS MOD(TEL,NKUB)=0

            GOTO 50
         ENDIF

C HAAL CEL VAN STACK, EN ONDERZOEK ZIJN BUREN

         P=STACK(PTR)
         PTR=PTR-1
         DO 300 I=1,6
            Q=BUUR(I,P)
            IF(Q.EQ.0) GOTO 320
            IF(SPACE(Q).EQ.1) THEN

C ZET DEZE BUUR OP STACK, EN MARKEER HEM MET 2, ZODAT HIJ NIET
C NOG EENS OP DE STACK KOMT

               SPACE(Q)=2
               PTR=PTR+1
               STACK(PTR)=Q
               TEL=TEL+1
            ENDIF

  300    CONTINUE
  320    CONTINUE

         GOTO 200

      END

      SUBROUTINE DUMP(SPACE,IPACE,BUUR,T,LL,STNR,PRSTCK,AANTAL,
     +                STACK,SYMS,IANTAL,FILEN)
         IMPLICIT INTEGER(A-Z)

         PARAMETER(NTMAX=15000)
         PARAMETER(NKUB=5)
         PARAMETER(NSTEEN=12)
         PARAMETER(DUMMY=0)

         DIMENSION SPACE(*),IPACE(*),BUUR(6,*),T(NTMAX,NKUB),
     +             STNR(*),PRSTCK(*),AANTAL(*),STACK(*),IANTAL(*)
         DIMENSION SYMS(3,*),LL(*)
         CHARACTER*(*) FILEN
         DOUBLE PRECISION TIMER,TMAX


         COMMON /BLOCK/ NN(3)
         COMMON /INVAR/ LOOP,NR,STATUS,NPROB,NBEGIN,NBEGIN1,
     +                  NEIND,METHOD,NBINGO,LSPACE,NSTACK,
     +                  NTMAX1,NRMAX,NSYMS,NS1,NS2

         COMMON /TIJD/ TIMER,TMAX

         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS

         OPEN(IDUMP,FILE=FILEN)
         CLOSE(IDUMP,STATUS='DELETE')
         OPEN(IDUMP,FILE=FILEN,FORM='FORMATTED')


    1    FORMAT(1X,A8,I10)

         WRITE(IDUMP,1) 'LOOP    ', LOOP

         WRITE(IDUMP,1) 'N1      ', NN(1)
         WRITE(IDUMP,1) 'N2      ', NN(2)
         WRITE(IDUMP,1) 'N3      ', NN(3)

         WRITE(IDUMP,1) 'NR      ', NR
         WRITE(IDUMP,1) 'STATUS  ', STATUS
         WRITE(IDUMP,1) 'NPROB   ', NPROB
         WRITE(IDUMP,1) 'NBEGIN  ', NBEGIN
         WRITE(IDUMP,1) 'NBEGIN1 ', NBEGIN1
         WRITE(IDUMP,1) 'NEIND   ', NEIND
         WRITE(IDUMP,1) 'NBINGO  ', NBINGO
         WRITE(IDUMP,1) 'LSPACE  ', LSPACE
         WRITE(IDUMP,1) 'NSTACK  ', NSTACK
         WRITE(IDUMP,1) 'NTMAX1  ', NTMAX1
         WRITE(IDUMP,1) 'NRMAX   ', NRMAX
         WRITE(IDUMP,1) 'NSYMS   ', NSYMS
         WRITE(IDUMP,1) 'NS1     ', NS1
         WRITE(IDUMP,1) 'NS2     ', NS2

         N123=NN(1)*NN(2)*NN(3)

         WRITE(IDUMP,1) 'SPACE   ',DUMMY
         WRITE(IDUMP,3) (SPACE(I),I=1,N123)
    3    FORMAT(1X,10I4)

         WRITE(IDUMP,1) 'IPACE   ',DUMMY
         WRITE(IDUMP,4) (IPACE(I),I=1,N123)
    4    FORMAT(1X,10I4)

         WRITE(IDUMP,1) 'BUUR    ',DUMMY
         WRITE(IDUMP,5) ((BUUR(I,J),I=1,6),J=1,N123)
    5    FORMAT(1X,6I4)

         WRITE(IDUMP,1) 'T       ',DUMMY
         DO 100 I=1,NEIND
            WRITE(IDUMP,6)  STNR(I),LL(I),(T(I,J),J=1,NKUB)
  100    CONTINUE
    6    FORMAT(1X,16I4)

         WRITE(IDUMP,1) 'PRSTCK  ',DUMMY
         WRITE(IDUMP,7) (PRSTCK(I),I=1,NR-1)
    7    FORMAT(1X,4I6)

         WRITE(IDUMP,1) 'AANTAL  ',DUMMY
         WRITE(IDUMP,8) (AANTAL(I),I=1,NSTEEN)
    8    FORMAT(1X,6I4)

         WRITE(IDUMP,1) 'STACK   ',DUMMY
         WRITE(IDUMP,9) (STACK(I),I=1,NSTACK)
    9    FORMAT(1X,4I8)

         WRITE(IDUMP,1) 'IANTAL  ',DUMMY
         WRITE(IDUMP,11) (IANTAL(I),I=1,NSTEEN)
   11    FORMAT(1X,6I4)

         WRITE(IDUMP,1) 'SYMS    ',DUMMY
         WRITE(IDUMP,12) ((SYMS(I,J),I=1,3),J=1,NSYMS)
   12    FORMAT(1X,3I4)

         CLOSE(IDUMP)
         RETURN
      END

      SUBROUTINE LEES(SPACE,IPACE,BUUR,T,LL,STNR,PRSTCK,AANTAL,
     +                STACK,SYMS,IANTAL,N123,FILEN)
         IMPLICIT INTEGER(A-Z)

         PARAMETER(NTMAX=15000)
         PARAMETER(NKUB=5)
         PARAMETER(NSTEEN=12)

         DIMENSION SPACE(*),IPACE(*),BUUR(6,*),T(NTMAX,NKUB),
     +             STNR(*),PRSTCK(*),AANTAL(*),STACK(*),IANTAL(*)
         DIMENSION SYMS(3,*),LL(*)
         CHARACTER*(*) FILEN

         DOUBLE PRECISION TIMER,TMAX
         CHARACTER*8 NAAM

         COMMON /BLOCK/ NN(3)
         COMMON /INVAR/ LOOP,NR,STATUS,NPROB,NBEGIN,NBEGIN1,
     +                  NEIND,METHOD,NBINGO,LSPACE,NSTACK,
     +                  NTMAX1,NRMAX,NSYMS,NS1,NS2

         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS

         OPEN(IDUMP,FILE=FILEN,FORM='FORMATTED')

         CALL ILEESN(IDUMP,'LOOP    ',LOOP)

         CALL ILEESN(IDUMP,'N1      ',NN(1))
         CALL ILEESN(IDUMP,'N2      ',NN(2))
         CALL ILEESN(IDUMP,'N3      ',NN(3))

         CALL ILEESN(IDUMP,'NR      ',NR)
         CALL ILEESN(IDUMP,'STATUS  ',STATUS)
         CALL ILEESN(IDUMP,'NPROB   ',NPROB)
         CALL ILEESN(IDUMP,'NBEGIN  ',NBEGIN)
         CALL ILEESN(IDUMP,'NBEGIN1 ',NBEGIN1)
         CALL ILEESN(IDUMP,'NEIND   ',NEIND)
         CALL ILEESN(IDUMP,'NBINGO  ',NBINGO)
         CALL ILEESN(IDUMP,'LSPACE  ',LSPACE)
         CALL ILEESN(IDUMP,'NSTACK  ',NSTACK)
         CALL ILEESN(IDUMP,'NTMAX1  ',NTMAX1)
         CALL ILEESN(IDUMP,'NRMAX   ',NRMAX)
         CALL ILEESN(IDUMP,'NSYMS   ',NSYMS)
         CALL ILEESN(IDUMP,'NS1     ',NS1)
         CALL ILEESN(IDUMP,'NS2     ',NS2)

         N123=NN(1)*NN(2)*NN(3)

         CALL ILEESN(IDUMP,'SPACE   ',DUMMY)
    2    FORMAT(1X,A8)
         READ(IDUMP,3) (SPACE(I),I=1,N123)
    3    FORMAT(1X,10I4)

         CALL ILEESN(IDUMP,'IPACE   ',DUMMY)
         READ(IDUMP,4) (IPACE(I),I=1,N123)
    4    FORMAT(1X,10I4)

         CALL ILEESN(IDUMP,'BUUR    ',DUMMY)
         READ(IDUMP,5) ((BUUR(I,J),I=1,6),J=1,N123)
    5    FORMAT(1X,6I4)

         CALL ILEESN(IDUMP,'T       ',DUMMY)
         DO 100 I=1,NEIND
            READ(IDUMP,6)  STNR(I),LL(I),(T(I,J),J=1,NKUB)
  100    CONTINUE
    6    FORMAT(1X,16I4)

         CALL ILEESN(IDUMP,'PRSTCK  ',DUMMY)
         READ(IDUMP,7) (PRSTCK(I),I=1,NR-1)
    7    FORMAT(1X,4I6)

         CALL ILEESN(IDUMP,'AANTAL  ',DUMMY)
         READ(IDUMP,8) (AANTAL(I),I=1,NSTEEN)
    8    FORMAT(1X,6I4)

         CALL ILEESN(IDUMP,'STACK   ',DUMMY)
         READ(IDUMP,9) (STACK(I),I=1,NSTACK)
    9    FORMAT(1X,4I8)

         CALL ILEESN(IDUMP,'IANTAL  ',DUMMY)
         READ(IDUMP,11) (IANTAL(I),I=1,NSTEEN)
   11    FORMAT(1X,6I4)

         CALL ILEESN(IDUMP,'SYMS    ',DUMMY)
         READ(IDUMP,12) ((SYMS(I,J),I=1,3),J=1,NSYMS)
   12    FORMAT(1X,3I4)

         CLOSE(IDUMP)
         RETURN
      END

      FUNCTION KIESF()
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NFDUMP=2)
         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS
         COMMON /CDUMP/ FDUMP(NFDUMP)
         CHARACTER*8 FDUMP
         LM=0
         K=0
         DO 100 I=1,NFDUMP
            CLOSE(IDUMP)
            OPEN(IDUMP,FILE=FDUMP(I),FORM='FORMATTED',STATUS='OLD',
     +            ERR=60)
            CALL ILEESN(IDUMP,'LOOP',L)
C DEBUG
            PRINT *,L,LM,FDUMP(I)
            IF(L.GT.LM) THEN
               LM=L
               K=I
            ENDIF
            GOTO 100
  60        CONTINUE
C DEBUG
            PRINT *,'KIESF: OPEN ERROR FILE ',FDUMP(I)
  100    CONTINUE

         IF(K.EQ.0) THEN
            PRINT *,'DUMPFILE NIET GEVONDEN'
            CALL STOPPEN
         ELSE
            PRINT *,'TE GEBRUIKEN DUMPFILE: ',FDUMP(K)
         ENDIF

         CLOSE(IDUMP)

         KIESF=K
         RETURN
      END

      SUBROUTINE DFDUMP
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NFDUMP=2)
         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS
         COMMON /CDUMP/ FDUMP(NFDUMP)
         CHARACTER*8 FDUMP

         CLOSE(IDUMP)

         DO 200 I=1,NFDUMP
            OPEN(IDUMP,FILE=FDUMP(I))
            CLOSE(IDUMP,STATUS='DELETE')
C DEBUG
            PRINT *,'FILE ',FDUMP(I),' WEGGEGOOID'
  200    CONTINUE

         CLOSE(IDUMP)

         RETURN
      END

      SUBROUTINE ILEESN(FILE,NAAM,W)
         IMPLICIT INTEGER(A-Z)
         CHARACTER*(*) NAAM
         CHARACTER*8 NAAM1
         READ(FILE,1,ERR=100,END=100) NAAM1,W

C DEBUG
         PRINT *,NAAM,W
    1    FORMAT(1X,A8,I10)
         IF(NAAM1.NE.NAAM) THEN
            PRINT *,'FOUT IN SUBROUTINE ILEESN'
            PRINT *,'VERWACHT NAAM: ''',NAAM,''''
            PRINT *,'GEVONDEN NAAM: ''',NAAM1,''''
            PRINT *,'PROGRAMMA WORDT GESTOPT'
            CALL STOPPEN
         ENDIF
         GOTO 900
  100    CONTINUE
         PRINT *,'FOUT IN SUBROUTINE ILEESN'
         PRINT *,'END OF FILE OF ERROR BIJ LEZEN VAN NAAM: ''',NAAM,''''
         PRINT *,'PROGRAMMA WORDT GESTOPT'
         CALL STOPPEN
  900    CONTINUE
         RETURN
      END

      SUBROUTINE DEFAULT
         IMPLICIT INTEGER(A-Z)
         PARAMETER(NFDUMP=2)
         COMMON /PR/ PRLOOP,PRBING
         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS
         COMMON /CDUMP/ FDUMP(NFDUMP)
         CHARACTER*8 FDUMP
C ***********************************************************
C
C MACHINE AFHANKELIJK
C   ZIE OOK FUNCTION CPTIME EN SUBROUTINE DEFAULT
C

C
C TIJDCHECK EN REGEL UITVOER NA PRLOOP LOOPS
C
C     PRLOOP=100
         PRLOOP=10000

C
C OPLOSSING PRINTEN BIJ PRBING OF MEER GEPLAATSTE STENEN
C
C     PRBING=11
C     PRBING=12
         PRBING=13
C
C STANDAARD UITVOER (6 VOOR IBM)
C     IU=9
         IU=6

C UITVOER VOOR DUMP

         IDUMP=21

C UITVOER SCRATCH

         ISCRA=22

C UITVOER VAN DE OPLOSSINGEN SEC

         IOPLOS=23
         DO 10 I=1,NFDUMP
            WRITE(FDUMP(I),11) I
   10    CONTINUE
   11    FORMAT('FADUMP',I2.2)
C DEBUG
         PRINT *,FDUMP
         RETURN
      END




      SUBROUTINE STOPPEN
         IMPLICIT INTEGER(A-Z)
         PRINT *,'PROGRAMMA STOPT NA ENTER'
         READ (*,*,END=1000)
 1000    CONTINUE
         STOP
      END

      SUBROUTINE LTMAX
         IMPLICIT INTEGER(A-Z)
         DOUBLE PRECISION TIMER,TMAX
         COMMON /TIJD/ TIMER,TMAX
         PRINT *,'MAXIMAAL AANTAL SECONDEN?'
         READ *,TMAX
         RETURN
      END

      SUBROUTINE TESTEQ(T,LL,SYMS,N1,N2,NS1,NS2)

C
C EEN JUIST GEBRUIK VAN DEZE SUBROUTINE VOORKOMT HET PRODUCEREN
C VAN DUBBELE OPLOSSINGEN.
C
C ELEMENTEN VAN LL(N1+1..N2) WORDEN NUL, WAAR ZICH IN T
C EEN SYMMETRIE EQUIVALENT VAN T(N1,*) BEVINDT.
C HET AANTAL SYMMETRIE OPERATIES, DAT PRECIES DEZELFDE
C PLAATS VOOR DE STEENPOSITIE T(N1,*) OPLEVERT, WORDT
C GETELD. VERDER WORDEN DIE SYMMETRIE OPERATIES VOORAAN
C IN HET ARRAY SYMS GEZET DOOR VERWISSELING MET ANDERE.
C BIJ HET PLAATSEN VAN EEN VOLGENDE STEEN BEHOEVEN SLECHTS
C DEZE SYMMETRIE OPERATIES TE WORDEN BEKEKEN. INDIEN ER
C NOG MAAR EEN SYMMETRIE OPERATIE OVER IS (DE EENHEIDS-
C OPERATIE) KAN DEZE HELE SUBROUTINE WORDEN GESKIPT). DE
C TEST OP 1 WORDT ECHTER NIET IN DEZE SUBROUTINE UITGEVOERD.
C
C METHODE
C
C EEN VOOR EEN WORDEN DE SYMMETRIE EQUIVALENTEN VAN T(N1,*)
C GEGENEREERD. DOOR SIMPEL VERGELIJKEN MET DE ELEMENTEN
C IN T(N1+1..N2,*) WORDT BEKEKEN, OF HET EEN SYMMETRIEEQUIVALENT
C BETREFT.
C DE SYMMETRIEOPERATIES DIE DE STEEN T(N1,*) IN ZICHZELF
C OVERVOEREN WORDEN GEMERKT EN NA AFLOOP DOOR VERWISSELING
C NAAR DE EERSTE POSITIES GESCHOVEN. NUMMER 1 (DE EENHEIDS
C OPERATIE BLIJFT OP ZIJN PLAATS)
C
C INPUT:
C  T(NTMAX,NKUB)     DE PARAMETERS VAN DE STENEN
C  LL(NTMAX)         ZIE BESCHRIJVING. (ZIE OOK OUTPUT)
C  SYMS(3,NSYMMAX)   DE SYMMETRIE OPERATIES (ZIE OOK OUTPUT)
C  N1                ZIE BESCHRIJVING
C  N2                ZIE BESCHRIJVING
C  NS1               AANTAL SYMMETRIE OPERATIES
C
C OUTPUT
C  LL(NTMAX)         ZIE BESCHRIJVING
C  SYMS(3,NSYMMAX)   BEVAT DEZELFDE OPERATIES ALS BIJ INPUT,
C                    MOGELIJKERWIJS IN EEN ANDERE VOLGORDE,
C                    EERSTE IS NOG STEEDS EERSTE
C  NS2               AANTAL SYMMETRIEOPERATIES, DAT DE STEEN
C                    T(N1,*) IN ZICHZELF OVERVOERT.

         IMPLICIT INTEGER(A-Z)
         PARAMETER(NSYMMAX=49)
         PARAMETER(NKUB=5)
         PARAMETER(NTMAX=15000)
         DIMENSION T(NTMAX,NKUB)
         DIMENSION LL(NTMAX)
         DIMENSION SYMS(3,NSYMMAX)
         DIMENSION MARK(NSYMMAX)
         DIMENSION X(3),X1(3),XX(NKUB)

         COMMON /BLOCK/ NN(3)
         COMMON /IO/ IU,IDUMP,ISCRA,IOPLOS

C
         MARK(1)=1
         NM=1
         DO 20 I=1,NS1
            MARK(I)=0
   20    CONTINUE


         DO 800 I=2,NS1
            DO 200 K=1,NKUB
               CALL DECO(T(N1,K),X)
               DO 120 L=1,3
                  X1(L)=X(ABS(SYMS(L,I)))
                  IF(SYMS(L,I).LT.0) X1(L)=NN(L)-X1(L)-1
  120          CONTINUE
               XX(K)=1+X1(1)+NN(1)*(X1(2)+NN(2)*X1(3))
  200       CONTINUE
            CALL BSORT(XX,NKUB)

C ONDERZOEK, OF DEZELFDE POSITIE IS GEGENEREERD. ZO JA,
C MARKEER DE SYMMETRIE OPERATIE

            DO 250 J=1,NKUB
               IF(XX(J).NE.T(N1,J)) GOTO 260
  250       CONTINUE
            MARK(I)=1
            NM=NM+1
            GOTO 410
  260       CONTINUE

C MARKEER NU DE STENEN, DIE IDENTIEK ZIJN AAN DE SYMMETRIE EQUIVALENTEN
C NIET NODIG, ALS DEZELFDE POSITIE WAS GEGENEREERD

            DO 400 J=N1+1,N2
               DO 350 L=1,NKUB
                  IF(XX(L).NE.T(J,L)) GOTO 355
  350          CONTINUE
               LL(J)=0
  355          CONTINUE
  400       CONTINUE

  410       CONTINUE

  800    CONTINUE

C
C PLAATS NU DE NM SYMMETRIE OPERATIES, DIE ALLES IN ZICHZELF OVERVOEREN
C AAN HET BEGIN VAN ARRAY SYMS

         JS=NS1
         DO 1000 I=2,NM
            IF(MARK(I).NE.0) GOTO 1000
            DO 990 J=JS,I+1,-1
               IF(MARK(J).NE.0) THEN
                  DO 980 K=1,3
                     Y=SYMS(K,J)
                     SYMS(K,J)=SYMS(K,I)
                     SYMS(K,I)=Y
  980             CONTINUE
                  JS=J-1
                  GOTO 1000
               ENDIF
  990       CONTINUE
 1000    CONTINUE

         NS2=NM

         RETURN
      END

c ATARI version of CPTIME:

c      FUNCTION CPTIME()
c      DOUBLE PRECISION CPTIME
c      INTEGER*4 SUPER
c      PARAMETER (SUPER     = Z'00000902')
c      INTEGER*4 STACK,ATARI,TIMER
c      STACK=0
c      STACK=ATARI(SUPER,STACK)
c      TIMER=LONG(1210)
c      STACK=ATARI(SUPER,STACK)
c      CPTIME=TIMER*0.005D0
c      RETURN
c      END


c VAX VMS version of CPTIME:
C
C     FUNCTION CPTIME()
C     DOUBLE PRECISION CPTIME
C     SAVE IFF,TIMER_ADDR
C     INTEGER*4 TIMER_ADDR,STATUS,IFF,ITIME,LIB$STAT_TIMER,TWEE
C     DATA IFF /0/,TWEE /2/
C
C     IF (IFF.EQ.0) THEN
C        STATUS=LIB$INIT_TIMER(TIMER_ADDR)
C        IFF=1
C     ENDIF
C
C     STATUS=LIB$STAT_TIMER(TWEE,ITIME,TIMER_ADDR)
C     CPTIME=ITIME*0.01
C     RETURN
C     END
C   
C IBM VERSIE
C

c      FUNCTION CPTIME()
c      DOUBLE PRECISION CPTIME,T
c      CALL CPUTIME(T,I)
c      CPTIME=T*1.0E-6
c      RETURN
c      END
C CDC VERSION OF CPTIME

C       FUNCTION CPTIME()
C       DOUBLE PRECISION CPTIME
C       CPTIME=SECOND()
C       RETURN
C       END

c   SUN VERSIE
C       DOUBLE PRECISION FUNCTION CPTIME()
C       REAL T(2)
C       CPTIME=ETIME(T)
C       RETURN
C           END
C RS6000 AIX versie
c        FUNCTION CPTIME()
c        DOUBLE PRECISION CPTIME
c        CPTIME=0.01D0*MCLOCK()
c        RETURN
c        END
c Linux g77 version
c	function cptime()
c	double precision cptime
c	cptime=1.0d-6*mclock()
c	return
c	end
      function cptime()
         real*8 klok
         external klok
         double precision cptime
         cptime=klok()
         return
      end
